(document:surround "/std/frame")

;;; UI
(gridbox
  columns "100"
  align "top"
  margin 10

  (label)
  (hbox
    (hbox align "left"
        (label text (_ "New account:") nameref "new_name")
        (edit name "new_name")
        (button text (_ "Create") name "new_button"))
    (hbox align "right"
        (document:id user_face (button name "user_face"
                                       pixmap (woo-get-option
                                                (woo-read-first "/users/get_current_face") 'face)
                                       visibility
                                       (not (string=? (woo-get-option
                                                        (woo-read-first "/users/get_current_face")
                                                        'face) "theme:null"))
                                       (when clicked (ui-show-face))))
        (label)
        (vbox align "center"
            (button (_ "Choose avatar") name "choose_avatar_btn"
                    (when clicked (ui-choose)))
            (spacer)
            (button (_ "Remove avatar") name "remove_avatar_btn" activity
                    (not (string=? (user_face pixmap) "theme:null"))
                    (when clicked (ui-remove-avatar))))))

  (separator)
  (splitbox
    columns "30;70"
    (listbox name "name" align "top" (when clicked (ui-select-user)))
    (gridbox
      columns "0;100"
      ;;
      (label text (_ "Comment:") align "right" nameref "gecos")
      (edit name "gecos")
      ;;
      (label text (_ "Home directory:") align "right" nameref "home")
      (edit name "home")
      ;;
      (label text (_ "Shell:") align "right" nameref "shell")
      (combobox name "shell")
      ;;
      (label colspan 2)

      (spacer)
      (checkbox text (_ "Member of administrators group") name "allow_su")
      ;;
      (label colspan 2)

      (spacer)
      (hbox
        (checklistbox name "system_roles" header (vector (_ "System roles assigned")))
        (listbox name "groups_list" header (vector (_ "Groups the user belongs to")))
      )
      ;;
      (label colspan 2)

      ;;
      (label text (_ "Password:") align "top;right")
      (gridbox
	columns "100;0"
	(checkbox text (_ "Generate automatically") name "auto")
	(spacer)
	(edit name "passwd_1" echo "stars")
	(label nameref "passwd_1" text (small (_ "(enter passphrase)")))
	(edit name "passwd_2" echo "stars")
	(label nameref "passwd_2" text (small (_ "(repeat passphrase)")))
	(edit name "passwd_auto" visibility #f alterability #f)
	(button text (_ "Generate") name "generate_button" visibility #f)
	(label colspan 2 nameref "passwd_auto" visibility #f)
	(checkbox text (_ "Autologin")
		  name "autologin"
		  visibility (woo-get-option
			       (woo-read-first "/users/allow_autologin")
		    'allow_autologin)))

      ;;
      (label colspan 2)

      ;;
      (label text (_ "Kiosk profile:") align "right" nameref "kiosk_profile")
      (combobox name "kiosk_profile")

      ;;
      (label colspan 2)

      ;;
      (spacer)
      (hbox align "left"
	    (button text (_ "Apply") name "apply_button")
	    (label)
	    (button text (_ "Delete user") name "delete_button")))))


(define (ui-choose)
  (form-popup "/users/choose")
  (user_face pixmap (woo-get-option
                      (woo-read-first "/users/set_face") 'face))
  (show-avatar-toggle)
  (remove-avatar-btn-toggle))

(define (ui-show-face)
  (if (not (string=? (user_face pixmap) "theme:null"))
  (begin (woo-write "/users/view_face" 'face (user_face pixmap)) (form-popup "/users/show_face"))))

(define (ui-select-user)
  (woo-call "/users/get_current_face")
  (user_face pixmap (woo-get-option
                      (woo-read-first "/users/set_face" 'name (form-value "name")) 'face))
  (show-avatar-toggle)
  (remove-avatar-btn-toggle))

(define (remove-avatar-btn-toggle)
  (if (ui-check-set-avatar) (form-update-activity "remove_avatar_btn" #t)
    (form-update-activity "remove_avatar_btn" #f)))

(define (show-avatar-toggle)
  (if (ui-check-set-avatar) (form-update-visibility "user_face" #t)
    (form-update-visibility "user_face" #f)))

(define (ui-check-set-avatar)
  (not (string=? (user_face pixmap) "theme:null")))

(define (ui-remove-avatar)
  (woo-call "/users/remove_avatar" 'name (form-value "name"))
  (user_face pixmap (woo-get-option (woo-read-first "/users/set_face") 'face))
  (remove-avatar-btn-toggle)
  (show-avatar-toggle))
